#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:ttype, :parent => PuppetX::EnterpriseModules::Mq::TopicProperty) do
  desc <<-DESC
  The topic type to manage. Valid types are:
  - TODO

  This is an immutable property. So you cannot change it.

  DESC

  def self.translate_to_resource(raw_resource, _resource)
    raw_resource[:output].scan(/TYPE\((.*?)\)/).flatten.first
  end

  def insync?(current_value)
    fail "#{path}: Your must recreate the object when changing it's type." if (current_value != should) && (resource[:ensure] == :present)
  end

  on_create do
    # The create uses this value to construct the command
  end
end
