#
# See the file "LICENSE" for the full license governing this code.
#

newparam(:name) do
  include EasyType

  desc <<-DESC
    The full name of the subscription. A subscription's full name constists of the name of the
    Queue manager a slash and then the name of the subscription. Here is an example:

        QMGR1/SUBNAME

  DESC

  isnamevar

  to_translate_to_resource do |raw_resource|
    qmgr         = raw_resource[:qmgr]
    subscription = raw_resource[:name]
    "#{qmgr}/#{subscription}"
  end
end
